/*
 * Created on 20/mar/07
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package it.polito.elite.listeners;

import it.polito.elite.visualization.ontoviewer.scenes3D.SceneFocusRoots1;
import it.polito.elite.visualization.ontoviewer.userInterfaces.Pane3DScene;
import it.polito.elite.visualization.ontoviewer.userInterfaces.SimpleSelectionTreePanel;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.DefaultListModel;
import javax.swing.JList;

/**
 * Action executed when the "add to View" button in the logic view panel is pressed
 * @author Alessio
 *
 */
public class AddToViewListener implements ActionListener
{
	private JList resultList;
	private Pane3DScene viewerPanel;
	private DefaultListModel listModel;
	private SimpleSelectionTreePanel treePanel;
	
	public AddToViewListener(JList resultList, DefaultListModel listModel, Pane3DScene viewer)
	{
		this.resultList = resultList;
		this.viewerPanel = viewer;
		this.listModel =listModel;
	}
	
	public AddToViewListener(SimpleSelectionTreePanel treePanel, DefaultListModel listModel, Pane3DScene viewer )
	{
		this.listModel = listModel;
		this.viewerPanel = viewer;
		this.treePanel = treePanel;
	}

	public void actionPerformed(ActionEvent e)
	{
//		If no view is currently loaded or defined it creates a default current one
		boolean save2Model=true;
		if(this.viewerPanel.currentLogicViewName == null){
			this.viewerPanel.currentLogicViewName = new String ("noname");
			save2Model = false;
		}
//		iterating over the element in the result set and adding to the current working set
//		an hashset stored in pane3D that holds the elements pertaining to the current view
		Object[] elenco = null;
		if(this.resultList != null)
			elenco = this.resultList.getSelectedValues();
		else
			elenco = this.listModel.toArray();
		
		for(int i=0;elenco!= null && i<elenco.length;i++){
			String resourceURI = (String) elenco[i];
			this.viewerPanel.conceptsOfCurrentLogicView.add(resourceURI);
			//removing element from the data model 
			this.listModel.removeElement(elenco[i]);
		}
		// redraw component
		if(this.treePanel != null)
			this.treePanel.redrawTree();
		
		//saving the view in the model
		if(save2Model){
			this.viewerPanel.model.saveViewElements(this.viewerPanel.currentLogicViewName,
				this.viewerPanel.conceptsOfCurrentLogicView);
		}
		//creating a new view comprising the added elements
		SceneFocusRoots1 myScene = new SceneFocusRoots1(this.viewerPanel,
				this.viewerPanel.conceptsOfCurrentLogicView);
		this.viewerPanel.changeScene(myScene);

	}

}
