package it.polito.elite.ontosphere3dplugin;

import org.eclipse.ui.IFolderLayout;
import org.eclipse.ui.IPageLayout;
import org.eclipse.ui.IPerspectiveFactory;

public class ontosphere3D_Perspective implements IPerspectiveFactory {
	
	public static final String ID_VIEW = "it.polito.elite.ontosphere3dplugin.ontosphere3D_Perspective";
	
	public ontosphere3D_Perspective(){}
	
	public void createInitialLayout(IPageLayout layout) {
		defineActions(layout);
	    defineLayout(layout);
	}
	
	public void defineActions(IPageLayout layout) {
        // Add "new wizards".
        //layout.addNewWizardShortcut("org.eclipse.ui.wizards.new.folder");
        //layout.addNewWizardShortcut("org.eclipse.ui.wizards.new.file");

        // Add "show views".
        layout.addShowViewShortcut(OntoSelectorView.ID_VIEW);
        layout.addShowViewShortcut(ClassTreeView.ID_VIEW);
        layout.addShowViewShortcut(ControlPanelView.ID_VIEW);
        layout.addShowViewShortcut(SubjectAreaView.ID_VIEW);
        layout.addShowViewShortcut(PropertyView.ID_VIEW);
        layout.addShowViewShortcut(OntoSphereView.ID_VIEW);
	}
	
	public void defineLayout(IPageLayout layout) {
        // Editors are placed for free.
		layout.setEditorAreaVisible(false);
		String editorArea=layout.getEditorArea();

        // Placing elements
        IFolderLayout left =  layout.createFolder("left", IPageLayout.LEFT, (float) 0.3, editorArea);
        left.addView(ClassTreeView.ID_VIEW);
        left.addView(ControlPanelView.ID_VIEW);
        left.addView(SubjectAreaView.ID_VIEW);
        
        IFolderLayout topleft =  layout.createFolder("topleft", IPageLayout.TOP, (float) 0.15, "left");
        topleft.addView(OntoSelectorView.ID_VIEW);
        
        IFolderLayout right =  layout.createFolder("right", IPageLayout.RIGHT, (float) 0.7, editorArea);
        right.addView(OntoSphereView.ID_VIEW);
        right.addView(PropertyView.ID_VIEW);
        
        layout.getViewLayout(OntoSphereView.ID_VIEW).setCloseable(false);
	}
	
	
}
