package it.polito.elite.visualization.ontoviewer.userInterfaces;

import java.awt.Color;
import java.awt.Component;
import java.awt.Font;
import java.net.URL;

import javax.swing.DefaultListModel;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTree;
import javax.swing.SwingConstants;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeCellRenderer;

public class LayoutEditor_TreeCellRenderer extends DefaultTreeCellRenderer {
	private DefaultListModel resList;
	private Pane3DScene viewerPanel;
	private JTree tree;
	
	public LayoutEditor_TreeCellRenderer(DefaultListModel resList, Pane3DScene viewer, JTree tree) {
		super();
		this.resList = resList;
		this.viewerPanel = viewer;
		this.tree = tree;
	}

	public Component getTreeCellRendererComponent(JTree tree, Object value,
			boolean selected, boolean expanded, boolean leaf, int row,
			boolean hasFocus) {
		JPanel cellPane = new JPanel();
		cellPane.setBackground(Color.WHITE);
		if (value instanceof DefaultMutableTreeNode) {
			DefaultMutableTreeNode node = (DefaultMutableTreeNode) value;
			String uri = (String) node.getUserObject();
			JLabel lab = new JLabel(uri, JLabel.CENTER);
			lab.setFont(new Font("Arial", Font.BOLD, 11));
			JLabel iconLabel;
			URL url =this.getClass().getClassLoader().getResource("resources/checkbox_ON.gif");
			ImageIcon icon_ON = new ImageIcon(url);

			url =this.getClass().getClassLoader().getResource("resources/checkbox_OFF.gif");
			ImageIcon icon_OFF = new ImageIcon(url);

			if (this.viewerPanel.conceptsOfCurrentLogicView != null && 
					this.viewerPanel.conceptsOfCurrentLogicView.contains(uri)) {
				lab.setForeground(Color.BLUE);
				lab.setToolTipText("The concept is already part of the current view");
			}

			boolean isChecked=false;
			if(this.resList.contains(uri)){
				iconLabel=new JLabel(icon_ON, SwingConstants.CENTER);
				isChecked=true;
			}
			else{
				iconLabel=new JLabel(icon_OFF, SwingConstants.CENTER);
			}

			if (selected) {
				if (!isChecked) {
					this.resList.addElement(uri);
					iconLabel=new JLabel(icon_ON, SwingConstants.CENTER);
				} else {
					this.resList.removeElement(uri);
					iconLabel=new JLabel(icon_OFF, SwingConstants.CENTER);
				}
				this.tree.clearSelection();
			} else {
				lab.setBackground(Color.WHITE);
				iconLabel.setBackground(Color.WHITE);
			}

			cellPane.add(lab);
			cellPane.add(iconLabel);
		}
		return cellPane;
	}

}
